Index: /trunk/bp-core/admin/bp-core-update.php
===================================================================
--- /trunk/bp-core/admin/bp-core-update.php	(revision 3727)
+++ /trunk/bp-core/admin/bp-core-update.php	(revision 3728)
@@ -12,6 +12,4 @@
 
 /**
- * bp_core_activate_site_options()
- *
  * When switching from single to multisite we need to copy blog options to
  * site options.
@@ -91,12 +89,12 @@
 		global $wp_rewrite;
 
+		// Setup wizard steps
 		if ( 'new' == $this->setup_type ) {
-			// Setup wizard steps
 			$steps = array(
 				__( 'Components', 'buddypress' ),
-				__( 'Pages', 'buddypress' ),
+				__( 'Pages',      'buddypress' ),
 				__( 'Permalinks', 'buddypress' ),
-				__( 'Theme', 'buddypress' ),
-				__( 'Finish', 'buddypress' )
+				__( 'Theme',      'buddypress' ),
+				__( 'Finish',     'buddypress' )
 			);
 
@@ -108,7 +106,7 @@
 				$steps = array_merge( array(), $steps );
 			}
+
+		// Update wizard steps
 		} else {
-			// Update wizard steps
-
 			if ( $this->is_network_activate )
 				$steps[] = __( 'Multisite Update', 'buddypress' );
@@ -167,19 +165,10 @@
 			<div id="bp-admin-header">
 				<h3><?php _e( 'BuddyPress', 'buddypress' ) ?></h3>
-				<h2>
-					<?php if ( 'update' == $this->setup_type ) : ?>
-
-						<?php _e( 'Update', 'buddypress' ) ?>
-
-					<?php else : ?>
-
-						<?php _e( 'Setup', 'buddypress' ) ?>
-
-					<?php endif; ?>
-				</h2>
+				<h2><?php ( 'update' == $this->setup_type ) ? _e( 'Update', 'buddypress' ) : _e( 'Setup', 'buddypress' ); ?></h2>
 			</div>
 
 			<?php
 				do_action( 'bp_admin_notices' );
+
 				$step_count  = count( $this->steps ) - 1;
 				$wiz_or_set  = $this->current_step >= $step_count ? 'bp-general-settings' : 'bp-wizard';
@@ -190,14 +179,23 @@
 				<div id="bp-admin-nav">
 					<ol>
+
 						<?php foreach( (array)$this->steps as $i => $name ) : ?>
+
 							<li<?php if ( $this->current_step == $i ) : ?> class="current"<?php endif; ?>>
 								<?php if ( $this->current_step > $i ) : ?>
+
 									<span class="complete">&nbsp;</span>
-								<?php else : ?>
-									<?php echo $i + 1 . '. ' ?>
-								<?php endif; ?>
-								<?php echo esc_attr( $name ) ?>
+
+								<?php else :
+
+									echo $i + 1 . '. ';
+
+								endif;
+								echo esc_attr( $name ) ?>
+
 							</li>
+
 						<?php endforeach; ?>
+
 					</ol>
 					<div class="prev-next submit clear">
@@ -207,4 +205,5 @@
 
 				<div id="bp-admin-content">
+
 					<?php switch ( $this->steps[$this->current_step] ) {
 						case __( 'Database Update', 'buddypress'):
@@ -233,17 +232,18 @@
 							break;
 					} ?>
+
 				</div>
 			</form>
-
-		</div>
+		</div>
+
 	<?php
 	}
 
-	/* Setup Step HTML */
+	// Setup Step HTML
 
 	function step_db_update() {
 		if ( !current_user_can( 'activate_plugins' ) )
-			return false;
-	?>
+			return false; ?>
+
 		<div class="prev-next submit clear">
 			<p><input type="submit" value="<?php _e( 'Update &amp; Next &rarr;', 'buddypress' ) ?>" name="submit" /></p>
@@ -257,6 +257,9 @@
 			<input type="hidden" name="save" value="db_update" />
 			<input type="hidden" name="step" value="<?php echo esc_attr( $this->current_step ) ?>" />
+
 			<?php wp_nonce_field( 'bpwizard_db_update' ) ?>
-		</div>
+
+		</div>
+
 	<?php
 	}
@@ -319,5 +322,7 @@
 			<input type="hidden" name="save" value="ms_update" />
 			<input type="hidden" name="step" value="<?php echo esc_attr( $this->current_step ) ?>" />
+
 			<?php wp_nonce_field( 'bpwizard_ms_update' ) ?>
+
 		</div>
 
@@ -327,7 +332,7 @@
 			});
 		</script>
+
 	<?php
 	}
-
 
 	function step_components() {
@@ -455,5 +460,5 @@
 		$disabled_components = apply_filters( 'bp_deactivated_components', get_site_option( 'bp-deactivated-components' ) );
 
-		/* Check for defined slugs */
+		// Check for defined slugs
 		if ( defined( 'BP_MEMBERS_SLUG' ) )
 			$members_slug = constant( 'BP_MEMBERS_SLUG' );
@@ -628,6 +633,5 @@
 
 		if ( !got_mod_rewrite() && !iis7_supports_permalinks() )
-			$prefix = '/index.php';
-	?>
+			$prefix = '/index.php'; ?>
 
 		<p><?php _e( "To make sure the pages we created in the previous step work correctly, you will need to enable permalink support on your site.", 'buddypress' ) ?></p>
@@ -654,5 +658,7 @@
 			<input type="hidden" name="save" value="permalinks" />
 			<input type="hidden" name="step" value="<?php echo esc_attr( $this->current_step ) ?>" />
+
 			<?php wp_nonce_field( 'bpwizard_permalinks' ) ?>
+
 		</div>
 	<?php
@@ -665,9 +671,9 @@
 		require_once( ABSPATH . WPINC . '/plugin.php' );
 		$installed_plugins = get_plugins();
-		$installed_themes = get_themes();
+		$installed_themes  = get_themes();
 
 		$template_pack_installed = false;
-		$bp_autotheme_installed = false;
-		$bp_theme_installed = false;
+		$bp_autotheme_installed  = false;
+		$bp_theme_installed      = false;
 
 		foreach ( (array)$installed_plugins as $plugin ) {
@@ -700,4 +706,5 @@
 				</td>
 			</tr>
+
 			<?php /*
 			<tr>
@@ -714,4 +721,5 @@
 			</tr>
 			*/ ?>
+
 			<tr>
 				<th>
@@ -732,4 +740,5 @@
 				</td>
 			</tr>
+
 			<tr>
 				<th>
@@ -774,4 +783,5 @@
 			});
 		</script>
+
 	<?php
 	}
@@ -811,5 +821,5 @@
 	}
 
-	/* Save Step Methods */
+	// Save Step Methods
 
 	function step_db_update_save() {
@@ -837,7 +847,7 @@
 			// Transfer important settings from blog options to site options
 			$options = array(
-				'bp-db-version' => $this->current_version,
+				'bp-db-version'             => $this->current_version,
 				'bp-deactivated-components' => $disabled,
-				'avatar-default' => get_option( 'avatar-default' )
+				'avatar-default'            => get_option( 'avatar-default' )
 			);
 			bp_core_activate_site_options( $options );
@@ -853,8 +863,6 @@
 
 				$existing_pages = get_option( 'bp-pages' );
-
-				$bp_pages = $this->setup_pages( (array)$_POST['bp_pages'] );
-
-				$bp_pages = array_merge( (array)$existing_pages, (array)$bp_pages );
+				$bp_pages       = $this->setup_pages( (array)$_POST['bp_pages'] );
+				$bp_pages       = array_merge( (array)$existing_pages, (array)$bp_pages );
 
 				update_option( 'bp-pages', $bp_pages );
@@ -942,4 +950,5 @@
 				if ( !empty($permalink_structure) )
 					$permalink_structure = preg_replace( '#/+#', '/', '/' . $_POST['permalink_structure'] );
+
 				if ( ( defined( 'VHOST' ) && constant( 'VHOST' ) == 'no' ) && $permalink_structure != '' && $current_site->domain.$current_site->path == $current_blog->domain.$current_blog->path )
 					$permalink_structure = '/blog' . $permalink_structure;
@@ -965,7 +974,8 @@
 			if ( $iis7_permalinks || ( !$usingpi && !$writable ) ) {
 				function _bp_core_wizard_step_permalinks_message() {
-					global $wp_rewrite;
-
-					?><div id="message" class="updated fade"><p>
+					global $wp_rewrite; ?>
+
+					<div id="message" class="updated fade"><p>
+
 					<?php
 						_e( 'Oops, there was a problem creating a configuration file. ', 'buddypress' );
@@ -982,10 +992,15 @@
 						}
 					?>
+
 					<br /><br />
+
 					<?php
 						if ( empty( $iis7_permalinks ) )
 							_e( 'Paste all these rules into a new <code>.htaccess</code> file in the root of your WordPress installation and save the file. Once you\'re done, please hit the "Save and Next" button to continue.', 'buddypress' );
 					?>
-					</p></div><?php
+
+					</p></div>
+
+				<?php
 				}
 				add_action( 'bp_admin_notices', '_bp_core_wizard_step_permalinks_message' );
@@ -1078,5 +1093,5 @@
 	}
 
-	/* Database update methods based on version numbers */
+	// Database update methods based on version numbers
 	function update_1_3() {
 		// Run the schema install to update tables
@@ -1085,7 +1100,7 @@
 		// Delete old database version options
 		delete_site_option( 'bp-activity-db-version' );
-		delete_site_option( 'bp-blogs-db-version' );
-		delete_site_option( 'bp-friends-db-version' );
-		delete_site_option( 'bp-groups-db-version' );
+		delete_site_option( 'bp-blogs-db-version'    );
+		delete_site_option( 'bp-friends-db-version'  );
+		delete_site_option( 'bp-groups-db-version'   );
 		delete_site_option( 'bp-messages-db-version' );
 		delete_site_option( 'bp-xprofile-db-version' );
@@ -1216,14 +1231,16 @@
 		$message = __( 'Installation was successful. The available options have now been updated, please continue with your selection.', 'buddypress' );
 	else
-		return false;
-?>
+		return false; ?>
+
 	<div id="message" class="updated">
 		<p><?php echo esc_attr( $message ) ?></p>
 	</div>
+
 <?php
 }
 add_action( 'bp_admin_notices', 'bp_core_wizard_message' );
 
-/* Alter thickbox screens so the entire plugin download and install interface is contained within. */
+// Alter thickbox screens so the entire plugin download and install
+// interface is contained within.
 function bp_core_wizard_thickbox() {
 	$form_action = is_multisite() ? network_admin_url( add_query_arg( array( 'page' => 'bp-wizard', 'updated' => '1' ), 'admin.php' ) ) : admin_url( add_query_arg( array( 'page' => 'bp-wizard', 'updated' => '1' ), 'admin.php' ) ); ?>
@@ -1242,4 +1259,5 @@
 		}
 	</script>
+
 <?php
 }
@@ -1247,6 +1265,4 @@
 
 /**
- * bp_core_add_admin_menu()
- *
  * Adds the "BuddyPress" admin submenu item to the Site Admin tab.
  *
@@ -1291,6 +1307,6 @@
 
 	wp_enqueue_script( 'thickbox' );
-	wp_enqueue_style( 'thickbox' );
-?>
+	wp_enqueue_style( 'thickbox' ); ?>
+
 	<style type="text/css">
 		/* Wizard Icon */
@@ -1310,6 +1326,8 @@
 		}
 	</style>
+
 <?php
 }
 add_action( 'admin_head', 'bp_core_add_admin_menu_styles' );
+
 ?>
Index: /trunk/bp-core/bp-core-deprecated.php
===================================================================
--- /trunk/bp-core/bp-core-deprecated.php	(revision 3728)
+++ /trunk/bp-core/bp-core-deprecated.php	(revision 3728)
@@ -0,0 +1,61 @@
+<?php
+
+/**
+ * Deprecated Functions
+ *
+ * @package BuddyPress
+ * @subpackage Core
+ *
+ */
+
+/**
+ * This function originally let plugins add support for pages in the root of the install.
+ * These pages are now handled by actual WordPress pages so this function is deprecated.
+ * It now simply facilitates backwards compatibility by adding a WP page if the plugin has not been
+ * updated to do so.
+ *
+ * @deprecated 1.3
+ * @deprecated Use wp_insert_post() to create a page
+ * @package BuddyPress Core
+ * @param $slug str The slug of the component
+ * @global $bp BuddyPress global settings
+ */
+function bp_core_add_root_component( $slug ) {
+	global $bp, $bp_pages;
+
+	_deprecated_function( __FUNCTION__, '1.3', 'wp_insert_post()' );
+	if ( empty( $bp_pages ) )
+		$bp_pages = bp_core_get_page_names();
+
+	$match = false;
+
+	// Check if the slug is registered in the $bp->pages global
+	foreach ( (array)$bp_pages as $key => $page ) {
+		if ( $key == $slug || $page->slug == $slug )
+			$match = true;
+	}
+
+	// If there was no match, add a page for this root component
+	if ( empty( $match ) ) {
+		$bp->add_root[] = $slug;
+		add_action( 'init', 'bp_core_create_root_component_page' );
+	}
+}
+
+function bp_core_create_root_component_page() {
+	global $bp;
+
+	$new_page_ids = array();
+
+	foreach ( (array)$bp->add_root as $slug )
+		$new_page_ids[$slug] = wp_insert_post( array( 'comment_status' => 'closed', 'ping_status' => 'closed', 'post_title' => ucwords( $slug ), 'post_status' => 'publish', 'post_type' => 'page' ) );
+
+	$page_ids = bp_core_get_page_meta();
+	$page_ids = (array) $page_ids;
+	$page_ids = array_merge( (array) $new_page_ids, (array) $page_ids );
+
+	bp_core_update_page_meta( $page_ids );
+}
+
+
+?>
Index: /trunk/bp-core/bp-core-templatetags.php
===================================================================
--- /trunk/bp-core/bp-core-templatetags.php	(revision 3727)
+++ /trunk/bp-core/bp-core-templatetags.php	(revision 3728)
@@ -163,5 +163,5 @@
 
 	// Make sure we return no members if we looking at friendship requests and there are none.
-	if ( empty( $include ) && $bp->friends->slug == $bp->current_component && 'requests' == $bp->current_action )
+	if ( empty( $include ) && bp_is_current_component( $bp->friends->slug ) && 'requests' == $bp->current_action )
 		return false;
 
@@ -583,10 +583,14 @@
 function bp_get_options_nav() {
 	global $bp;
-
-	if ( count( $bp->bp_options_nav[$bp->current_component] ) < 1 )
+	
+	// If we are looking at a member profile, then the we can use the current component as an
+	// index. Otherwise we need to use the component's root_slug
+	$component_index = !empty( $bp->displayed_user ) ? $bp->current_component : bp_get_root_slug( $bp->current_component );
+	
+	if ( count( $bp->bp_options_nav[$component_index] ) < 1 )
 		return false;
 
 	/* Loop through each navigation item */
-	foreach ( (array)$bp->bp_options_nav[$bp->current_component] as $subnav_item ) {
+	foreach ( (array)$bp->bp_options_nav[$component_index] as $subnav_item ) {
 		if ( !$subnav_item['user_has_access'] )
 			continue;
@@ -1557,5 +1561,131 @@
 	}
 
+/**
+ * Echoes the output of bp_get_root_slug()
+ *
+ * @package BuddyPress Core
+ * @since 1.3
+ */
+function bp_root_slug( $component = '' ) {
+	echo bp_get_root_slug( $component );
+}
+	/**
+	 * Gets the root slug for a component slug
+	 *
+	 * In order to maintain backward compatibility, the following procedure is used:
+	 * 1) Use the short slug to get the canonical component name from the
+	 *    active component array
+	 * 2) Use the component name to get the root slug out of the appropriate part of the $bp
+	 *    global
+	 * 3) If nothing turns up, it probably means that $component is itself a root slug
+	 *
+	 * Example: If your groups directory is at /community/companies, this function first uses
+	 * the short slug 'companies' (ie the current component) to look up the canonical name
+	 * 'groups' in $bp->active_components. Then it uses 'groups' to get the root slug, from
+	 * $bp->groups->root_slug.
+	 *
+	 * @package BuddyPress Core
+	 * @since 1.3
+	 *
+	 * @global $bp The global BuddyPress settings variable created in bp_core_setup_globals()
+	 * @param string $component Optional. Defaults to the current component
+	 * @return string $root_slug The root slug
+	 */
+	function bp_get_root_slug( $component = '' ) {
+		global $bp;
+
+		$root_slug = '';
+
+		// Use current global component if none passed
+		if ( empty( $component ) )
+			$component = $bp->current_component;
+
+		// Component is active
+		if ( !empty( $bp->active_components[$component] ) ) {
+			$component_name = $bp->active_components[$component];
+
+			// Component has specific root slug
+			if ( !empty( $bp->{$component_name}->root_slug ) ) 
+				$root_slug = $bp->{$component_name}->root_slug;
+		}
+
+		// No specific root slug, so fall back to component slug
+		if ( empty( $root_slug ) )
+			$root_slug = $component;
+
+		return apply_filters( 'bp_get_root_slug', $root_slug, $component );
+	}
+
 /* Template is_() functions to determine the current page */
+
+/**
+ * Checks to see whether the current page belongs to the specified component
+ *
+ * This function is designed to be generous, accepting several different kinds
+ * of value for the $component parameter. It checks $component_name against:
+ * - the component's root_slug, which matches the page slug in $bp->pages
+ * - the component's regular slug
+ * - the component's id, or 'canonical' name
+ *
+ * @package BuddyPress Core
+ * @since 1.3
+ * @return bool Returns true if the component matches, or else false.
+ */
+function bp_is_current_component( $component ) {
+	global $bp;
+
+	$is_current_component = false;
+
+	if ( !empty( $bp->current_component ) ) {
+
+		// First, check to see whether $component_name and the current
+		// component are a simple match
+		if ( $bp->current_component == $component ) {
+			$is_current_component = true;
+
+		// Next, check to see whether $component is a canonical,
+		// non-translatable component name. If so, we can return its
+		// corresponding slug from $bp->active_components.
+		} else if ( $key = array_search( $component, $bp->active_components ) ) {
+			if ( $key === $bp->current_component )
+				$is_current_component = true;
+
+		// If we haven't found a match yet, check against the root_slugs
+		// created by $bp->pages
+		} else {
+			foreach ( $bp->active_components as $key => $id ) {
+				// If the $component parameter does not match the current_component,
+				// then move along, these are not the droids you are looking for
+				if ( $bp->{$id}->root_slug != $bp->current_component )
+					continue;
+
+				if ( $key == $component ) {
+					$is_current_component = true;
+					break;
+				}
+			}
+		}
+	}
+
+ 	return apply_filters( 'bp_is_current_component', $is_current_component, $component_name );
+}
+
+/**
+ * Checks to see if a component's URL should be in the root, not under a member page:
+ * eg: http://domain.com/groups/the-group NOT http://domain.com/members/andy/groups/the-group
+ *
+ * @package BuddyPress Core
+ * @return true if root component, else false.
+ */
+function bp_is_root_component( $component_name ) {
+	global $bp;
+
+	foreach ( (array) $bp->active_components as $key => $slug ) {
+		if ( $key == $component_name || $slug == $component_name )
+			return true;
+	}
+
+	return false;
+}
 
 /**
@@ -1591,5 +1721,5 @@
 		return true;
 
-	if ( !$bp->displayed_user->id && !$bp->is_single_item && ( !isset( $bp->is_directory ) || !$bp->is_directory ) && !bp_core_is_root_component( $bp->current_component ) )
+	if ( !$bp->displayed_user->id && !$bp->is_single_item && ( !isset( $bp->is_directory ) || !$bp->is_directory ) && !bp_is_root_component( $bp->current_component ) )
 		return true;
 
@@ -1661,7 +1791,5 @@
 
 function bp_is_profile_component() {
-	global $bp;
-
-	if ( BP_XPROFILE_SLUG == $bp->current_component )
+	if ( bp_is_current_component( BP_XPROFILE_SLUG ) )
 		return true;
 
@@ -1670,7 +1798,5 @@
 
 function bp_is_activity_component() {
-	global $bp;
-
-	if ( BP_ACTIVITY_SLUG == $bp->current_component )
+	if ( bp_is_current_component( BP_ACTIVITY_SLUG ) )
 		return true;
 
@@ -1679,7 +1805,5 @@
 
 function bp_is_blogs_component() {
-	global $bp;
-
-	if ( is_multisite() && BP_BLOGS_SLUG == $bp->current_component )
+	if ( is_multisite() && bp_is_current_component( BP_BLOGS_SLUG ) )
 		return true;
 
@@ -1688,7 +1812,5 @@
 
 function bp_is_messages_component() {
-	global $bp;
-
-	if ( BP_MESSAGES_SLUG == $bp->current_component )
+	if ( bp_is_current_component( BP_MESSAGES_SLUG ) )
 		return true;
 
@@ -1697,7 +1819,5 @@
 
 function bp_is_friends_component() {
-	global $bp;
-
-	if ( BP_FRIENDS_SLUG == $bp->current_component )
+	if ( bp_is_current_component( BP_FRIENDS_SLUG ) )
 		return true;
 
@@ -1706,7 +1826,5 @@
 
 function bp_is_groups_component() {
-	global $bp;
-
-	if ( BP_GROUPS_SLUG == $bp->current_component )
+	if ( bp_is_current_component( BP_GROUPS_SLUG ) )
 		return true;
 
@@ -1715,7 +1833,5 @@
 
 function bp_is_settings_component() {
-	global $bp;
-
-	if ( BP_SETTINGS_SLUG == $bp->current_component )
+	if ( bp_is_current_component( BP_SETTINGS_SLUG ) )
 		return true;
 
@@ -1735,5 +1851,5 @@
 	global $bp;
 
-	if ( $bp->activity->slug == $bp->current_component )
+	if ( bp_is_current_component( $bp->activity->slug ) )
 		return true;
 
@@ -1744,5 +1860,5 @@
 	global $bp;
 
-	if ( $bp->activity->slug == $bp->current_component && 'my-friends' == $bp->current_action )
+	if ( bp_is_current_component( $bp->activity->slug ) && 'my-friends' == $bp->current_action )
 		return true;
 
@@ -1753,5 +1869,5 @@
 	global $bp;
 
-	if ( BP_ACTIVITY_SLUG == $bp->current_component && is_numeric( $bp->current_action ) )
+	if ( bp_is_current_component( BP_ACTIVITY_SLUG ) && is_numeric( $bp->current_action ) )
 		return true;
 
@@ -1762,5 +1878,5 @@
 	global $bp;
 
-	if ( defined( 'BP_XPROFILE_SLUG' ) && BP_XPROFILE_SLUG == $bp->current_component || isset( $bp->core->profile->slug ) && $bp->core->profile->slug == $bp->current_component )
+	if ( defined( 'BP_XPROFILE_SLUG' ) && bp_is_current_component( BP_XPROFILE_SLUG ) || isset( $bp->core->profile->slug ) && bp_is_current_component( $bp->core->profile->slug ) )
 		return true;
 
@@ -1771,5 +1887,5 @@
 	global $bp;
 
-	if ( BP_XPROFILE_SLUG == $bp->current_component && 'edit' == $bp->current_action )
+	if ( bp_is_current_component( BP_XPROFILE_SLUG ) && 'edit' == $bp->current_action )
 		return true;
 
@@ -1780,5 +1896,5 @@
 	global $bp;
 
-	if ( BP_XPROFILE_SLUG == $bp->current_component && 'change-avatar' == $bp->current_action )
+	if ( bp_is_current_component( BP_XPROFILE_SLUG ) && 'change-avatar' == $bp->current_action )
 		return true;
 
@@ -1788,6 +1904,6 @@
 function bp_is_user_groups() {
 	global $bp;
-
-	if ( $bp->groups->slug == $bp->current_component )
+	
+	if ( bp_is_current_component( BP_GROUPS_SLUG ) )
 		return true;
 
@@ -1797,6 +1913,6 @@
 function bp_is_group() {
 	global $bp;
-
-	if ( BP_GROUPS_SLUG == $bp->current_component && isset( $bp->groups->current_group ) && $bp->groups->current_group )
+	
+	if ( bp_is_current_component( BP_GROUPS_SLUG ) && isset( $bp->groups->current_group ) && $bp->groups->current_group )
 		return true;
 
@@ -1807,5 +1923,5 @@
 	global $bp;
 
-	if ( BP_GROUPS_SLUG == $bp->current_component && $bp->is_single_item && ( !$bp->current_action || 'home' == $bp->current_action ) )
+	if ( bp_is_current_component( BP_GROUPS_SLUG ) && $bp->is_single_item && ( !$bp->current_action || 'home' == $bp->current_action ) )
 		return true;
 
@@ -1816,5 +1932,5 @@
 	global $bp;
 
-	if ( BP_GROUPS_SLUG == $bp->current_component && 'create' == $bp->current_action )
+	if ( bp_is_current_component( BP_GROUPS_SLUG ) && 'create' == $bp->current_action )
 		return true;
 
@@ -1826,5 +1942,5 @@
 	global $bp;
 
-	if ( BP_GROUPS_SLUG == $bp->current_component && $bp->is_single_item && 'admin' == $bp->current_action )
+	if ( bp_is_current_component( BP_GROUPS_SLUG ) && $bp->is_single_item && 'admin' == $bp->current_action )
 		return true;
 
@@ -1835,5 +1951,5 @@
 	global $bp;
 
-	if ( BP_GROUPS_SLUG == $bp->current_component && $bp->is_single_item && 'forum' == $bp->current_action )
+	if ( bp_is_current_component( BP_GROUPS_SLUG ) && $bp->is_single_item && 'forum' == $bp->current_action )
 		return true;
 
@@ -1844,5 +1960,5 @@
 	global $bp;
 
-	if ( BP_GROUPS_SLUG == $bp->current_component && $bp->is_single_item && 'activity' == $bp->current_action )
+	if ( bp_is_current_component( BP_GROUPS_SLUG ) && $bp->is_single_item && 'activity' == $bp->current_action )
 		return true;
 
@@ -1853,5 +1969,5 @@
 	global $bp;
 
-	if ( BP_GROUPS_SLUG == $bp->current_component && $bp->is_single_item && 'forum' == $bp->current_action && isset( $bp->action_variables[0] ) && 'topic' == $bp->action_variables[0] )
+	if ( bp_is_current_component( BP_GROUPS_SLUG ) && $bp->is_single_item && 'forum' == $bp->current_action && isset( $bp->action_variables[0] ) && 'topic' == $bp->action_variables[0] )
 		return true;
 
@@ -1862,5 +1978,5 @@
 	global $bp;
 
-	if ( BP_GROUPS_SLUG == $bp->current_component && $bp->is_single_item && 'forum' == $bp->current_action && isset( $bp->action_variables[0] ) && 'topic' == $bp->action_variables[0] && isset( $bp->action_variables[2] ) && 'edit' == $bp->action_variables[2] )
+	if ( bp_is_current_component( BP_GROUPS_SLUG ) && $bp->is_single_item && 'forum' == $bp->current_action && isset( $bp->action_variables[0] ) && 'topic' == $bp->action_variables[0] && isset( $bp->action_variables[2] ) && 'edit' == $bp->action_variables[2] )
 		return true;
 
@@ -1871,5 +1987,5 @@
 	global $bp;
 
-	if ( BP_GROUPS_SLUG == $bp->current_component && $bp->is_single_item && 'members' == $bp->current_action )
+	if ( bp_is_current_component( BP_GROUPS_SLUG ) && $bp->is_single_item && 'members' == $bp->current_action )
 		return true;
 
@@ -1880,5 +1996,5 @@
 	global $bp;
 
-	if ( BP_GROUPS_SLUG == $bp->current_component && 'send-invites' == $bp->current_action )
+	if ( bp_is_current_component( BP_GROUPS_SLUG ) && 'send-invites' == $bp->current_action )
 		return true;
 
@@ -1889,5 +2005,5 @@
 	global $bp;
 
-	if ( BP_GROUPS_SLUG == $bp->current_component && 'request-membership' == $bp->current_action )
+	if ( bp_is_current_component( BP_GROUPS_SLUG ) && 'request-membership' == $bp->current_action )
 		return true;
 
@@ -1898,5 +2014,5 @@
 	global $bp;
 
-	if ( BP_GROUPS_SLUG == $bp->current_component && $bp->is_single_item && 'leave-group' == $bp->current_action )
+	if ( bp_is_current_component( BP_GROUPS_SLUG ) && $bp->is_single_item && 'leave-group' == $bp->current_action )
 		return true;
 
@@ -1907,5 +2023,5 @@
 	global $bp;
 
-	if ( BP_GROUPS_SLUG == $bp->current_component && $bp->is_single_item )
+	if ( bp_is_current_component( BP_GROUPS_SLUG ) && $bp->is_single_item )
 		return true;
 
@@ -1916,5 +2032,5 @@
 	global $bp;
 
-	if ( is_multisite() && BP_BLOGS_SLUG == $bp->current_component )
+	if ( is_multisite() && bp_is_current_component( BP_BLOGS_SLUG ) )
 		return true;
 
@@ -1925,5 +2041,5 @@
 	global $bp;
 
-	if ( is_multisite() && BP_BLOGS_SLUG == $bp->current_component && 'recent-posts' == $bp->current_action )
+	if ( is_multisite() && bp_is_current_component( BP_BLOGS_SLUG ) && 'recent-posts' == $bp->current_action )
 		return true;
 
@@ -1934,5 +2050,5 @@
 	global $bp;
 
-	if ( is_multisite() && BP_BLOGS_SLUG == $bp->current_component && 'recent-comments' == $bp->current_action )
+	if ( is_multisite() && bp_is_current_component( BP_BLOGS_SLUG ) && 'recent-comments' == $bp->current_action )
 		return true;
 
@@ -1943,5 +2059,5 @@
 	global $bp;
 
-	if ( is_multisite() && BP_BLOGS_SLUG == $bp->current_component && 'create' == $bp->current_action )
+	if ( is_multisite() && bp_is_current_component( BP_BLOGS_SLUG ) && 'create' == $bp->current_action )
 		return true;
 
@@ -1950,7 +2066,5 @@
 
 function bp_is_user_friends() {
-	global $bp;
-
-	if ( BP_FRIENDS_SLUG == $bp->current_component )
+	if ( bp_is_current_component( BP_FRIENDS_SLUG ) )
 		return true;
 
@@ -1961,5 +2075,5 @@
 	global $bp;
 
-	if ( BP_FRIENDS_SLUG == $bp->current_component && 'requests' == $bp->current_action )
+	if ( bp_is_current_component( BP_FRIENDS_SLUG ) && 'requests' == $bp->current_action )
 		return true;
 
@@ -1968,7 +2082,5 @@
 
 function bp_is_user_messages() {
-	global $bp;
-
-	if ( BP_MESSAGES_SLUG == $bp->current_component )
+	if ( bp_is_current_component( BP_MESSAGES_SLUG ) )
 		return true;
 
@@ -1979,5 +2091,5 @@
 	global $bp;
 
-	if ( BP_MESSAGES_SLUG == $bp->current_component && ( !$bp->current_action || 'inbox' == $bp->current_action ) )
+	if ( bp_is_current_component( BP_MESSAGES_SLUG ) && ( !$bp->current_action || 'inbox' == $bp->current_action ) )
 		return true;
 
@@ -1988,5 +2100,5 @@
 	global $bp;
 
-	if ( BP_MESSAGES_SLUG == $bp->current_component && 'sentbox' == $bp->current_action )
+	if ( bp_is_current_component( BP_MESSAGES_SLUG ) && 'sentbox' == $bp->current_action )
 		return true;
 
@@ -1998,5 +2110,5 @@
 	global $bp;
 
-	if ( BP_MESSAGES_SLUG == $bp->current_component && 'notices' == $bp->current_action )
+	if ( bp_is_current_component( BP_MESSAGES_SLUG ) && 'notices' == $bp->current_action )
 		return true;
 
@@ -2008,5 +2120,5 @@
 	global $bp;
 
-	if ( BP_MESSAGES_SLUG == $bp->current_component && 'compose' == $bp->current_action )
+	if ( bp_is_current_component( BP_MESSAGES_SLUG ) && 'compose' == $bp->current_action )
 		return true;
 
@@ -2024,7 +2136,5 @@
 
 function bp_is_activation_page() {
-	global $bp;
-
-	if ( BP_ACTIVATION_SLUG == $bp->current_component )
+	if ( bp_is_current_component( BP_ACTIVATION_SLUG ) )
 		return true;
 
@@ -2033,7 +2143,5 @@
 
 function bp_is_register_page() {
-	global $bp;
-
-	if ( BP_REGISTER_SLUG == $bp->current_component )
+	if ( bp_is_current_component( BP_REGISTER_SLUG ) )
 		return true;
 
